%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

# TODO(jpena): There is no python3-neutron-lib yet, so let's skip python3 for now
%if 0%{?fedora} >= 24
%global with_python3 0
%endif

%global pypi_name vmware-nsxlib
%global module vmware_nsxlib

Name:           python-%{pypi_name}
Version:        12.0.4
Release:        2%{?dist}
Summary:        A common library that interfaces with VMware NSX

License:        ASL 2.0
URL:            https://github.com/openstack/vmware-nsxlib
Source0:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{version}.tar.gz

#patches_ignore=DROP-IN-RPM
#patches_base=12.0.4
Patch0001: 0001-Fixed-tenacity-usage.patch
Patch0002: 0002-Add-logging-when-initializing-a-default-FW-section.patch
Patch0003: 0003-Remove-sha224-from-supported-client-cert-hash-algs.patch
Patch0004: 0004-Retry-on-503-Service-Unavailable.patch
Patch0005: 0005-Escape-illegal-chars-in-LS-name.patch
Patch0006: 0006-Add-retry-to-firewall-section-delete.patch
Patch0007: 0007-Fix-section-rules-protocols-handling.patch
Patch0008: 0008-Fix-service-ports-for-egress-firewall-rule.patch
Patch0009: 0009-Validate-ICMP-type-code-for-section-rules.patch
Patch0010: 0010-Support-MP-cluster-unavailable-managers.patch
Patch0011: 0011-NSX-V3-Support-new-icmp-codes-and-types-list.patch
Patch0012: 0012-New-api-for-getting-the-LB-virtual-servers-status.patch
Patch0013: 0013-New-api-for-getting-VPN-session-status.patch
Patch0014: 0014-Add-revision_id-when-creating-FW-rule.patch
Patch0015: 0015-Fix-cluster-connectivity.patch
Patch0016: 0016-Amend-allowed-ICMP-types-and-codes-in-strict-mode.patch
Patch0017: 0017-Fix-multi-cluster-connectivity.patch
Patch0018: 0018-Update-the-max-NS-groups-criteria-tags-number-dynami.patch

BuildArch:      noarch

%package -n     python2-%{pypi_name}
Summary:        A common library that interfaces with VMware NSX
%{?python_provide:%python_provide python2-%{pypi_name}}

BuildRequires:  git
BuildRequires:  python2-fixtures
BuildRequires:  python-requests-mock
BuildRequires:  python2-setuptools
BuildRequires:  python2-subunit
BuildRequires:  python2-testrepository
BuildRequires:  python2-testscenarios
BuildRequires:  python2-testtools
BuildRequires:  python2-devel
BuildRequires:  python2-hacking
BuildRequires:  python2-mock
BuildRequires:  python-neutron-lib
BuildRequires:  python2-oslo-sphinx
BuildRequires:  python2-oslotest
BuildRequires:  python2-pbr
BuildRequires:  python2-reno
BuildRequires:  python2-sphinx
BuildRequires:  python2-tenacity
BuildRequires:  python2-testresources
BuildRequires:  python2-sphinx
Requires:       python2-pbr >= 2.0.0
Requires:       python2-eventlet >= 0.18.2
Requires:       python2-netaddr >= 0.7.18
Requires:       python2-tenacity >= 3.2.1
Requires:       python2-six >= 1.10.0
Requires:       python-neutron-lib >= 1.13.0
Requires:       python2-oslo-i18n >= 3.15.3
Requires:       python2-oslo-log >= 3.36.0
Requires:       python2-oslo-serialization >= 2.18.0
Requires:       python2-oslo-service >= 1.24.0
Requires:       python2-oslo-utils >= 3.33.0
Requires:       python2-pyOpenSSL >= 16.2.0
Requires:       python-enum34

%description -n python2-%{pypi_name}
vmware-nsxlib is a common library that interfaces with VMware NSX


%package -n python2-%{pypi_name}-tests
Summary:    A common library that interfaces with VMware NSX - tests
Requires:   python2-%{pypi_name} = %{version}-%{release}

%description -n python2-%{pypi_name}-tests
A common library that interfaces with VMware NSX

This package contains the test files.


%package -n python-%{pypi_name}-doc
Summary:        vmware-nsxlib documentation
%description -n python-%{pypi_name}-doc
Documentation for vmware-nsxlib


%if 0%{?with_python3}
%package -n     python3-%{pypi_name}
Summary:        A common library that interfaces with VMware NSX
%{?python_provide:%python_provide python3-%{pypi_name}}
BuildRequires:  python3-fixtures
BuildRequires:  python3-requests-mock
BuildRequires:  python3-setuptools
BuildRequires:  python3-subunit
BuildRequires:  python3-testrepository
BuildRequires:  python3-testscenarios
BuildRequires:  python3-testtools
BuildRequires:  python3-devel
BuildRequires:  python3-hacking
BuildRequires:  python3-mock
BuildRequires:  python3-neutron-lib
BuildRequires:  python3-oslo-sphinx
BuildRequires:  python3-oslotest
BuildRequires:  python3-pbr
BuildRequires:  python3-reno
BuildRequires:  python3-sphinx
BuildRequires:  python3-tenacity
BuildRequires:  python3-testresources
Requires:       python3-pbr >= 2.0.0
Requires:       python3-eventlet >= 0.18.2
Requires:       python3-netaddr >= 0.7.18
Requires:       python3-tenacity >= 3.2.1
Requires:       python3-six >= 1.10.0
Requires:       python3-neutron-lib >= 1.13.0
Requires:       python3-oslo-i18n >= 3.15.3
Requires:       python3-oslo-log >= 3.36.0
Requires:       python3-oslo-serialization >= 2.18.0
Requires:       python3-oslo-service >= 1.24.0
Requires:       python3-oslo-utils >= 3.33.0
Requires:       python3-pyOpenSSL >= 16.2.0
%description -n python3-%{pypi_name}
vmware-nsxlib is a common library that interfaces with VMware NSX

%package -n python3-%{pypi_name}-tests
Summary:    A common library that interfaces with VMware NSX - tests
Requires:   python3-%{pypi_name} = %{version}-%{release}

%description -n python3-%{pypi_name}-tests
A common library that interfaces with VMware NSX

This package contains the test files.
%endif # with_python3

%description
vmware-nsxlib is a common library that interfaces with VMware NSX


%prep
%autosetup -n %{pypi_name}-%{upstream_version} -S git
# Let's handle dependencies ourseleves
rm -f *requirements.txt
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif

# generate html docs
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

%install
%if 0%{?with_python3}
%py3_install
%endif
%py2_install

%check
%if 0%{?with_python3}
%{__python3} setup.py test
rm -rf .testrepository
%endif
%{__python2} setup.py test

%files -n python2-%{pypi_name}
%license LICENSE
%doc README.rst
%{python2_sitelib}/%{module}
%{python2_sitelib}/%{module}-*-py?.?.egg-info
%exclude %{python2_sitelib}/%{module}/tests

%files -n python2-%{pypi_name}-tests
%license LICENSE
%{python2_sitelib}/%{module}/tests

%files -n python-%{pypi_name}-doc
%license LICENSE
%doc html

%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%license LICENSE
%doc README.rst
%{python3_sitelib}/%{module}
%{python3_sitelib}/%{module}-*-py?.?.egg-info
%exclude %{python3_sitelib}/%{module}/tests

%files -n python3-%{pypi_name}-tests
%license LICENSE
%{python3_sitelib}/%{module}/tests
%endif

%changelog
* Wed Nov 28 2018 Jon Schlueter <jschluet@redhat.com> 12.0.4-2
- Update the max NS groups criteria tags number dynamically
- Fix multi-cluster connectivity
- update (rhbz#1654273)

* Wed Oct 17 2018 Steve Linabery <slinaber@redhat.com> 12.0.4-1
- Update to 12.0.4
- Amend allowed ICMP types and codes in strict mode
- Fix cluster connectivity
- Add revision_id when creating FW rule
- New api for getting VPN session status
- New api for getting the LB virtual servers status
- NSX|V3: Support new icmp codes and types list
- Support MP cluster unavailable managers
- Validate ICMP type & code for section rules
- Fix service ports for egress firewall rule
- Fix section rules protocols handling
- Add retry to firewall section delete
- Escape illegal chars in LS name
- Retry on 503 Service Unavailable
- Remove sha224 from supported client cert hash algs
- Add logging when initializing a default FW section
- Fixed tenacity usage
